%%
% GETGUPDE: get jacobian for pde part used in full jacobian of getGu.
%
%  Gu=getGupde(p,u,r)
% Here "r" is the residual at u used in numjac
% Imporant switches: p.sw.jac, p.sw.sfem
%
% See also getGu, filltrafo, stanparam, numjac
function Gu=getGupde(p,u,r)
global pj; % for call of numjac
if(p.sw.jac==1) % pde-part analytically 
  if p.sw.sfem~=1 % use full jac
    bc=p.fuha.bcjac(p,u); upde=p.mat.fill*u(1:p.nu); 
    [cj,aj,bj]=p.fuha.Gjac(p,u); zerov=zeros(p.nc.neq,1); 
    [Gu,dum]=assempde(bc,p.mesh.p,p.mesh.e,p.mesh.t,cj,aj,zerov, upde); 
    if(any(bj)); Kadv=assemadv(p.mesh.p,p.mesh.t,bj); 
        Gu=Gu-Kadv; end 
    Gu=filltrafo(p,Gu);
    return;
  else % use "simple jac". Note that p.mat.fill is built in here already
      Gu=p.fuha.sGjac(p,u);
  end
else 
    bc=p.fuha.bcjac(p,u);
    [S,dum]=assempde(bc,p.mesh.p,p.mesh.e,p.mesh.t,...
            0,ones(p.nc.neq*p.nc.neq,1),ones(p.nc.neq,1),p.mat.fill*u(1:p.nu));
    S=filltrafo(p,S);
    thresh=p.nc.del*ones(p.nu,1); pj=p; pj.u=u;
    [Gu,dum,dum]=numjac('resinj',0,u(1:p.nu),r(1:p.nu),thresh,[],0,S,[]); 
end
