%%
% ILSS: IterativeLinearSystemSolver, template for customization by user 
% for preconditioning matrices, write global L U gmcount at command line
%
% x=ilss(A,b,p) 
%
% See also lss, blss 
% iterative solvers currently under revision!
function x=ilss(A,b,p)
global L U gmcount; 
%fprintf('\n iblss: iterative solvers currently under revision;'); 
%fprintf('\n        if needed, rather set up your own.\n ');
method=2; % switch to quickly check different methods ...
if method==1
 flag=1; 
 while(flag~=0)
  if(size(L,1)~=size(A,1)) 
      tic; setup.type='crout'; setup.droptol=0;
      [L,U]=ilu(A,setup);s1=toc; gmcount=0;
      if p.sw.verb>1;fprintf('new LU in %g\n',s1); end 
  end 
  tic;[x,flag,rr]=gmres(A,b,5,1e-6,10,L,U);s1=toc; gmcount=gmcount+1; 
  if flag==0; 
    if p.sw.verb>1; fprintf('ilss: gmres flag=%i, resi=%g, gmcount=%i, gmres-time=%g\n',flag, rr, gmcount,s1); end
  else if p.sw.verb>1; fprintf('ilss: gmres flag=%i, gm-resi=%g, ', flag, rr); end
     tic; setup.type='crout'; setup.droptol=0;
     [L,U]=ilu(A,setup);s1=toc; gmcount=0;
     if p.sw.verb>1; fprintf('ilss: new LU in %g\n',s1); end
  end
 end
end
% other options: 
%x=bicg(A,b,1e-6,15,L,U);toc
%x=bicgstab(A,b,1e-6,15,L,U);toc
%x=lsqr(A,b,1e-6,15,L,U);toc
%x=tfqmr(A,b,1e-6,15,L,U);toc
if method==2 % try precon with D^{-1}
 d=diag(A);n=length(d);dsm=spdiags(d,0,n,n);tic;
 [x,flag,rr,iter]=lsqr(A,b,1e-6,50,dsm);s1=toc; 
 fprintf('ilss: flag=%i, res=%g, iter=%i, time=%g\n',flag, rr, iter, s1);
end

