%%
% INISTEP: return p-structure and ok flag for (attempt of) initial
% continuation step done by incrementing Parameter and Newton loop.
% This yields first 2 points on branch and first tangent (secant) vector.
%
%  [p,iok]=inistep(p)
%
% Here iok convergence error flag.
%
% See also cont, nloop, stanparam.
function [p,iok]=inistep(p)
iok1=0;iok2=0; r=resi(p,p.u);res0=norm(r,p.sw.norm); 
[p.u,res]=nloop(p,p.u); ineg=-1; %p.sol.ptype=-1;
if(res<p.nc.tol) 
    fprintf('%4i got first point with lam=%g, res=%g \n',p.file.count,getlam(p),res);
    if(p.sw.spcalc>0); % spectral calc 
        r=resi(p,p.u); Gu=getGu(p,p.u,r); [ineg,muv]=spcalc(Gu,p); 
    end
    if(p.sw.errcheck>0); p.sol.err=errcheck(p);end 
    if(~isfield(p.sol,'ptype') || p.sol.ptype~=-2) p.sol.ptype=-1; end % initial point, unless from swibra
    brout=[bradat(p); p.fuha.outfu(p,p.u)]; % userfu to append to bif-branches  
    brplot=brout(length(bradat(p))+p.plot.bpcmp);
    p.branch=[p.branch brout]; % put on branch 
    figure(p.plot.brfig); hold on; % plot point     
    if(ineg<=0) plot(getlam(p),brplot,'*'); else plot(getlam(p),brplot,'+'); end 
    if p.file.smod~=0; p.fuha.savefu(p); % save to file 
           % fname=[p.file.pname,sprintf('%i',p.file.count),'.mat']; save(fname,'p'); 
    end 
    iok1=1;p.file.count=p.file.count+1; 
else fprintf('   - no convergence in zeroth step, lam=%g, res=%g\n',getlam(p),res);
end
u0=p.u; lam0=getlam(p); p.u(p.nu+p.nc.ilam(1))=lam0+p.sol.ds/10; 
fprintf('   - now lam=%g\n',getlam(p)); 
[u,res]=nloop(p,p.u); 
if(res<p.nc.tol) 
    fprintf('%4i got second point with lam=%g, res=%g \n',p.file.count,getlam(p),res);
    p.u=u; % update, was missing before!
    if(p.sw.spcalc>0); r=resi(p,u); Gu=getGu(p,u,r);    
        [ineg,muv]=spcalc(Gu,p); end
    if(p.sw.errcheck>0); p.sol.err=errcheck(p);end 
    brout=[bradat(p); p.fuha.outfu(p,p.u)]; % userfu to append to bif-branches  
    brplot=brout(length(bradat(p))+p.plot.bpcmp);
    p.branch=[p.branch brout]; % put on branch 
    p.sol.ptype=0; % normal point
    figure(p.plot.brfig); hold on; % plot point 
    if(ineg<=0) plot(getlam(p),brplot,'*'); else plot(getlam(p),brplot,'+'); end 
    if(mod(p.file.count-1,p.file.smod)==0) p.fuha.savefu(p); end  % save to file 
    iok2=1;p.file.count=p.file.count+1;
else fprintf('   - no convergence in first step, lam=%g, res=%g\n',getlam(p),res);
end
iok=iok1*iok2; 
tau=(u2au(p,p.u,1)-u2au(p,u0,1))/(getlam(p)-lam0);
%tau=[(u(1:p.nu+p.nc.nq)-p.u(1:p.nu+p.nc.nq))/(getlam(p)-lam); 1];
p.tau=tau/xinorm(tau,p.sol.xi,p.nc.nq,p.sol.xiq); 
p.sol.restart=0; p.sol.ineg=ineg; 
