%%
% PLOTSOL: plot component of p.u in struct p.
%
%  plotsol(p,wnr,cnr,pstyle)
%
% cnr=component number, wnr=window number, pstyle=plot style
% (sometimes needs reset if pstyle~=2 due to problems with axis:
%
%  if pstyle~=2 clf('reset'); else clf; end )
%
% See also plotsolf
function plotsol(p,wnr,cnr,pstyle)
if isempty(p.mesh); load(['mesh/m',num2str(p.file.mcount)]); p.mesh=single(m); end 
figure(wnr); 
clf
upde=p.mat.fill*p.u(1:p.nu); n0=(cnr-1)*p.np+1; n1=cnr*p.np;
if pstyle==0; pdemesh(p.mesh.p,p.mesh.e,p.mesh.t); end 
if pstyle==1; pdemesh(p.mesh.p,p.mesh.e,p.mesh.t,upde(n0:n1)); end 
if pstyle==2; pdeplot(p.mesh.p,p.mesh.e,p.mesh.t,'xydata',upde(n0:n1)); end 
if pstyle==3; h=pdesurf(p.mesh.p,p.mesh.t,upde(n0:n1));view(10,40);
   light('Position',p.plot.lpos,'Style','local','Color',[1 1 0]);
   lighting phong; 
   set(h,'FaceLighting','flat','FaceColor','interp','AmbientStrength',0.8); 
end
zax=mat2str(cnr);
xlabel('x'); ylabel('y'); zlabel(char(['comp.nr. ' zax]),'fontsize',p.plot.fs);

try colormap(p.plot.cm); catch, colormap gray; end; % cool, jet, autumn, lines 
if pstyle==4; pdemesh(p.mesh.p,p.mesh.e,p.mesh.t); end 
axis(p.plot.axis); box on; 
if p.plot.labelsw; xlabel('x','FontSize',p.plot.fs); ylabel('y','FontSize',p.plot.fs); end;
set(gca,'FontSize',p.plot.fs); 
