%%
% RMDATADIRS: remove data directories from subdirs of appdir (a cleanup tool)
%  typical call (e.g.): rmdatadirs('/home/hu/path/pde2path/demos'); 
%  which is also the default if no argument given. 
function rmdatadirs(varargin)
if(nargin==0); appdir='/home/hu/path/pde2path/demos'; 
else appdir=varargin{1};
end
startdir=pwd; 
cd(appdir); ok=0; allok=0; md=dir; mdl=length(md); 
for i=1:mdl
   cf=md(i); 
   if (cf.isdir==1 && ~strcmp(cf.name,'.') && ~strcmp(cf.name,'..'))
      cd([appdir,'/',cf.name]); 
      subdirs=dir; sdl=length(subdirs); 
      for j=1:sdl
        csubdir=subdirs(j);
        if (csubdir.isdir==1 && ...
               ~strcmp(csubdir.name,'.') && ~strcmp(csubdir.name,'..'))
           fprintf('%s: intending to remove %s \n', cf.name, csubdir.name); 
        end
      end
   end
end
allok=asknu('OK to all?', allok); 
cd(appdir)
for i=1:mdl
   cf=md(i); 
   if (cf.isdir==1 && ~strcmp(cf.name,'.') && ~strcmp(cf.name,'..'))
      cd([appdir,'/',cf.name]); 
      subdirs=dir; sdl=length(subdirs); 
      for j=1:sdl
        csubdir=subdirs(j);
        if (csubdir.isdir==1 && ...
               ~strcmp(csubdir.name,'.') && ~strcmp(csubdir.name,'..'))
           if ~allok
             fprintf('%s: intending to remove %s, ', cf.name, csubdir.name); 
             ok=asknu('OK?',ok); if ok; rmdir(csubdir.name,'s'); end
           end
           if allok; rmdir(csubdir.name,'s'); end
        end
      end
   end
end
cd(startdir); % return to calling directory 
