%% stationary BD for sloc 
path('../p2plib',path);path('../p2poclib',path);
%% Scenario 1, FSC/FSI branch 
close all; p=[];lx=2*pi/0.44; ly=0.1; nx=50; ny=1; sw=1; 
p=slinit(p,lx,ly,nx,ny,sw); p=setfn(p,'f1'); screenlayout(p); 
%% find bif.points from FSC/FSI branch 
p.nc.nsteps=100; p=cont(p); 
%% FSM branch 
sw=2; p=slinit(p,lx,ly,nx,ny,sw); p=setfn(p,'f2'); 
p.nc.dsmax=0.2; p.sol.ds=0.1; p=cont(p,25); 
%% bifurcations from f1 
p=swibra('f1','bpt1','p1',-0.05); p.nc.dsmax=0.3; p=cont(p,150); 
p=swibra('f1','bpt2','p2',-0.05); p.nc.dsmax=0.3; p=cont(p,150); 
p=swibra('f1','bpt3','p3',0.05); p.nc.dsmax=0.3; p=cont(p,150); 
%% plotting of BD, L2 over b
figure(3); clf; pcmp=3; ms=5; 
plotbraf('f1','bpt1',3,pcmp,'ms',ms,'lab',12,'cl','k'); % FSC 
plotbraf('f1','pt74',3,pcmp,'ms',ms,'fp',15,'cl','k','lt','.', 'lab',36); % FSI 
plotbraf('f2','pt25',3,pcmp,'ms',ms,'lab',[11 20],'cl','b','lp',23); % FSM 
plotbraf('p1','pt135',3,pcmp,'ms',ms,'cl','r','lab',[16 71]); 
plotbraf('p2','pt128',3,pcmp,'ms',ms,'cl','m','lab',18); 
plotbraf('p3','pt111',3,pcmp,'ms',ms,'cl','g','lab',19);
xlabel('b'); ylabel('||P||_{2,a}');
text(0.61,1.6,'FSM','color','b','fontsize',16);text(0.56,1.59,'p1','color','r','fontsize',16);
text(0.56,1.45,'p2','color','m','fontsize',16);text(0.56,1.28,'p3','color','g','fontsize',16);
text(0.56,1,'FSI','color','k','fontsize',16);text(0.56,0.5,'FSC','color','k','fontsize',16);
%% JC over b
figure(3); clf; pcmp=4; ms=0; 
plotbraf('f1','bpt1',3,pcmp,'ms',ms,'cl','k', 'lab',12); % FSC 
plotbraf('f1','pt74',3,pcmp,'ms',ms,'fp',22,'cl','k','lt','.'); % FSI 
plotbraf('f2','pt25',3,pcmp,'ms',ms,'cl','b','lab',20); % FSM 
plotbraf('p1','pt135',3,pcmp,'ms',ms,'cl','r','lab',16);
xlabel('b'); ylabel('J_{ca}'); axis([0.6 0.75 -2.7 -1.8])
%% solution plotting 
plot1Df('p1','pt16',1,1,1,2); pause; plot1Df('p1','pt71',1,1,1,2); pause
plot1Df('p2','pt18',1,1,1,2); pause; plot1Df('p3','pt19',1,1,1,2); 
%% print CSS characteristics (for tables)
stancssvalf('p1','pt16');





