%% stat. BD for vegOC; set matlab paths and init FSS branch 
clear all; path('../p2plib',path); path('../p2poclib',path); 
close all; p=[]; lx=5; nx=40; ny=1; ly=lx/nx; sw=1; rho=0.03; 
p=veginit(p,lx,ly,nx,ny,sw,rho); p=setfn(p,'FSS'); p0=p; screenlayout(p); 
%% find bif.points from FSS branch 
p=p0; p.nc.ilam=8; p.sol.ds=-1; p.nc.nsteps=100; p=findbif(p,10); 
%% recalculate branch to get usr-lam points
delete('FSS/pt*.mat'); % delete pt-output in dir FSS, to keep dir small 
p=p0; p.sol.ds=-1; p.sw.bifcheck=0; p=cont(p,45); 
p.sol.ds=-0.5; p.nc.dsmax=0.5; p=cont(p,100); % decrease ds to get around fold
%% bif from FSS 
p=swibra('FSS','bpt1','p1',-1); p.sw.bifcheck=0; p=cont(p,70); 
p=swibra('FSS','bpt2','p2',-2); p.sw.bifcheck=0; p=cont(p,100); 
p=swibra('FSS','bpt3','p3',-2); p.sw.bifcheck=0; p=cont(p,35); 
%% plot the BD, max v over R  
figure(3); clf; pcmp=1; 
plotbraf('FSS','pt140',3,pcmp,'cl','k','lab',[13,17,28,44,91],'labo',0,-40);
plotbraf('FSS','bpt4',3,pcmp,'cl','k'); 
plotbraf('p1','pt74',3,pcmp,'cl','b', 'lab',[11,16,34,38, 49, 65],'labo',1,0);
plotbraf('p2','pt97',3,pcmp,'cl','r', 'lab',[23 38],'labo',1,0);
plotbraf('p3','pt37',3,pcmp,'cl','m','lab',[8],'labo',1,0);
text(31,400,'FSS','fontsize',16);text(30,520,'p1','fontsize',16);
text(13.5,200,'p2','fontsize',16);text(24.5,570,'p3','fontsize',16);
xlabel('R'); ylabel('max v');
%% plot the BD, J_{c,a} over R 
figure(3); clf; pcmp=4; 
plotbraf('FSS','pt140',3,pcmp,'cl','k','lab',[13,17,28,44,72],'labo',0,1);
plotbraf('FSS','bpt4',3,pcmp,'cl','k'); 
plotbraf('p1','pt74',3,pcmp,'cl','b', 'lab',[11,16,34,38, 49, 65],'labo',1,0);
xlabel('R'); ylabel('J_{c,a}'); axis([19 30 12 29]);
%% soln plots 
plot1Df('p1','pt11',1,10,10,10,3);pause; plot1Df('p1','pt16',1,10,10,10,3);pause 
plot1Df('p1','pt34',1,10,10,10,3);pause; plot1Df('p1','pt38',1,10,10,10,3);pause 
plot1Df('p1','pt49',1,10,10,10,3);pause; plot1Df('p1','pt65',1,10,10,10,3);pause
plot1Df('p2','pt23',1,10,10,10,3);pause; plot1Df('p3','pt8',1,10,10,10,3);
%% values for table 
valf('FSS','pt13'); valf('FSS','pt17'); 



